//+------------------------------------------------------------------+
//|                                                     Vegas_H1.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Blue
#property indicator_width1	2
#property indicator_style1	STYLE_SOLID
#property indicator_color2 Red
#property indicator_width2	2
#property indicator_style2	STYLE_SOLID
#property indicator_color3 Blue
#property indicator_width3	1
#property indicator_style3	STYLE_DOT
#property indicator_color4 Blue
#property indicator_width4	1
#property indicator_style4	STYLE_DOT
#property indicator_color5 Blue
#property indicator_width5	1
#property indicator_style5	STYLE_DOT
#property indicator_color6 Red
#property indicator_width6	1
#property indicator_style6 STYLE_DOT
#property indicator_color7 Red
#property indicator_width7	1
#property indicator_style7	STYLE_DOT
#property indicator_color8 Red
#property indicator_width8 1
#property indicator_style8	STYLE_DOT
//---- input parameters
extern bool      Alerts=false;
extern int       RiskModel=1;
extern int       MA1=144;
extern int       MA2=169;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(7,ExtMapBuffer8);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int    counted_bars=IndicatorCounted();
  //---- check for possible errors
   if(counted_bars<0) return(-1);
  //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
  //---- main loop
     for(int i=0; i<limit; i++)
       {
        //---- ma_shift set to 0 because SetIndexShift called abowe
         ExtMapBuffer1[i]=iMA(NULL,0,MA1,0,MODE_EMA,PRICE_WEIGHTED,i);
         ExtMapBuffer2[i]=iMA(NULL,0,MA2,0,MODE_EMA,PRICE_WEIGHTED,i);
         
         //Model #1 89,144,233
         if(RiskModel==1)
         {
            ExtMapBuffer3[i]=ExtMapBuffer2[i]+890*Point;
            ExtMapBuffer4[i]=ExtMapBuffer2[i]+1440*Point;
            ExtMapBuffer5[i]=ExtMapBuffer2[i]+2330*Point;
            
            ExtMapBuffer6[i]=ExtMapBuffer2[i]-890*Point;
            ExtMapBuffer7[i]=ExtMapBuffer2[i]-1440*Point;
            ExtMapBuffer8[i]=ExtMapBuffer2[i]-2330*Point;    
         }
         
         //Model #2 144,233,377
         if(RiskModel==2)
         {
            ExtMapBuffer3[i]=ExtMapBuffer2[i]+1440*Point;
            ExtMapBuffer4[i]=ExtMapBuffer2[i]+2330*Point;
            ExtMapBuffer5[i]=ExtMapBuffer2[i]+3770*Point;
            
            ExtMapBuffer6[i]=ExtMapBuffer2[i]-1440*Point;
            ExtMapBuffer7[i]=ExtMapBuffer2[i]-2330*Point;   
            ExtMapBuffer8[i]=ExtMapBuffer2[i]-3770*Point;
         }
         
          //Model #3 233,377,610
         if(RiskModel==3)
         {
            ExtMapBuffer3[i]=ExtMapBuffer2[i]+2330*Point;
            ExtMapBuffer4[i]=ExtMapBuffer2[i]+3770*Point;
            ExtMapBuffer5[i]=ExtMapBuffer2[i]+6100*Point;
            
            ExtMapBuffer6[i]=ExtMapBuffer2[i]-2330*Point;
            ExtMapBuffer7[i]=ExtMapBuffer2[i]-3770*Point;
            ExtMapBuffer8[i]=ExtMapBuffer2[i]-6100*Point;    
         }
         
          //Model #4 377,610,987
         if(RiskModel==4)
         {
            ExtMapBuffer3[i]=ExtMapBuffer2[i]+3770*Point;
            ExtMapBuffer4[i]=ExtMapBuffer2[i]+6100*Point;
            ExtMapBuffer5[i]=ExtMapBuffer2[i]+9870*Point;
            
            ExtMapBuffer6[i]=ExtMapBuffer2[i]-3770*Point;
            ExtMapBuffer7[i]=ExtMapBuffer2[i]-6100*Point;
            ExtMapBuffer8[i]=ExtMapBuffer2[i]-9870*Point;    
         }
         
      //   Comment("\nRISK MODEL #",RiskModel," (1-4)\n\nEMA144 - ",ExtMapBuffer1[limit],"\nEMA169 - ",ExtMapBuffer2[limit], 
      //   "\n\nF+1 - ",ExtMapBuffer3[limit],"\nF+2 - ",ExtMapBuffer4[limit],
      //   "\nF+3 - ",ExtMapBuffer5[limit],"\n\nF-1 - ",ExtMapBuffer6[limit],
      //   "\nF-2 - ",ExtMapBuffer7[limit],"\nF-3 - ",ExtMapBuffer8[limit]);
       }
       
       //+--------------------------------------------------------------------------+
       //-                          ALERTS    PlaySound("alert.wav");               -
       //+--------------------------------------------------------------------------+
      if(Alerts)
      {
         if(Close[i]==ExtMapBuffer1[i] || Close[i]==ExtMapBuffer2[i])
         {
            PlaySound("alert.wav");
         }
         if(Close[i]==ExtMapBuffer3[i] || Close[i]==ExtMapBuffer4[i] || Close[i]==ExtMapBuffer5[i])
         {
            PlaySound("alert.wav");
         }
         if(Close[i]==ExtMapBuffer6[i] || Close[i]==ExtMapBuffer7[i] || Close[i]==ExtMapBuffer8[i])
         {
            PlaySound("alert.wav");
         }
      }
         
  //---- done

//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+